<?php
/*
	+-----------------------------------------------------------------------------+
	| ILIAS open source                                                           |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 1998-2001 ILIAS open source, University of Cologne            |
	|                                                                             |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
	+-----------------------------------------------------------------------------+
*/

require_once("./Modules/ScormAicc/classes/SCORM/class.ilSCORMObject.php");

/**
* SCORM Manifest
*
* @author Alex Killing <alex.killing@gmx.de>
* @version $Id: class.ilSCORMManifest.php 20408 2009-07-03 10:13:22Z nkrzywon $
*
* @ingroup ModulesScormAicc
*/
class ilSCORMManifest extends ilSCORMObject
{
	var $import_id;
	var $version;
	var $xml_base;


	/**
	* Constructor
	*
	* @param	int		$a_id		Object ID
	* @access	public
	*/
	function ilSCORMManifest($a_id = 0)
	{
		parent::ilSCORMObject($a_id);
		$this->setType("sma");
	}

	function getImportId()
	{
		return $this->import_id;
	}

	function setImportId($a_import_id)
	{
		$this->import_id = $a_import_id;
		$this->setTitle($a_import_id);
	}

	function getVersion()
	{
		return $this->version;
	}

	function setVersion($a_version)
	{
		$this->version = $a_version;
	}

	function getXmlBase()
	{
		return $this->xml_base;
	}

	function setXmlBase($a_xml_base)
	{
		$this->xml_base = $a_xml_base;
	}

	function read()
	{
		global $ilDB;
		
		parent::read();

		$obj_set = $ilDB->queryF('SELECT * FROM sc_manifest WHERE obj_id = %s',
		array('integer'),array($this->getId()));
		$obj_rec = $ilDB->fetchAssoc($obj_set);
		
		$this->setImportId($obj_rec["import_id"]);
		$this->setVersion($obj_rec["version"]);
		$this->setXmlBase($obj_rec["xml_base"]);
	}

	function create()
	{
		global $ilDB;
		
		parent::create();

		$ilDB->manipulateF('
		INSERT INTO sc_manifest (obj_id, import_id, version, xml_base) 
		VALUES (%s,%s,%s,%s)',
		array('integer','text','text','text'),
		array($this->getId(),$this->getImportId(),$this->getVersion(),$this->getXmlBase()));
		
	}

	function update()
	{
		global $ilDB;
		
		parent::update();

		$ilDB->manipulateF('
		UPDATE sc_manifest 
		SET import_id = %s,  
			version = %s,  
			xml_base = %s 
		WHERE obj_id = %s',
		array('text','text','text','integer'),
		array($this->getImportId(),$this->getVersion(),$this->getXmlBase(),$this->getId()));		
		
	}

	function delete()
	{
		global $ilDB;

		parent::delete();

		$ilDB->manipulateF('DELETE FROM sc_manifest WHERE obj_id = %s', array('integer'),array($this->getId()));
	}

}
?>
